package org.jsmpp.demo.util;

/**
 * @author uudashr
 *
 */
public class SimpleThrottle implements ThrottleControl {
    private final long timeInMillis;
    private int maxPerTime;
    private long nextResetTime;
    private int count;
    
    public SimpleThrottle(long timeInMillis, int maxPerTime) {
        this.timeInMillis = timeInMillis;
        this.maxPerTime = maxPerTime;
    }
    
    public synchronized void obtainTurn() throws InterruptedException {
        long waitTime = nextResetTime - System.currentTimeMillis();
        if (waitTime < 0) {
            reset(System.currentTimeMillis());
        } else if (count >= maxPerTime && waitTime > 0) {
            wait(waitTime);
            reset(System.currentTimeMillis());
        } else {
            count++;
        }
    }
    
    private void reset(long now) {
        nextResetTime = now + timeInMillis;
        count = 1;
    }
}
